//
// misc.h
//



extern	void ShowSystemErr(long err);
extern void	ErrorHandler(short);
extern void	DoAlert(Str255);
extern void	DoFatalAlert(Str255);
extern void	Wait(long);
extern Handle	LoadAFile(Str255, short, long *);
extern unsigned char	*NumToHex(unsigned short);
extern unsigned char	*NumToHex2(unsigned long, short);
extern unsigned char	*NumToDec(unsigned long);
extern	void CleanQuit(void);
extern	float Absolute(float f);
extern	void RegulateSpeed(long speed);
extern	void SetMyRandomSeed(unsigned long seed);
extern	unsigned long MyRandomLong(void);
extern	void FloatToString(float num, Str255 string);
extern	Handle	AllocHandle(long size);
extern	Ptr	AllocPtr(long size);
extern	void PrintFPS(void);
extern	void AngleToVector(float angle, TQ3Vector2D *theVector);
extern	unsigned short	RandomRange(unsigned short min, unsigned short max);
extern	Boolean UVsAreCloseEnough(TQ3Param2D *v1, TQ3Param2D *v2);
extern	void CopyPStr(ConstStr255Param	inSourceStr, StringPtr	outDestStr);
extern	float StringToFloat(Str255 textStr);





/************************** POINTS ARE CLOSE ENOUGH ****************************/

inline Boolean PointsAreCloseEnough(TQ3Point3D *v1, TQ3Point3D *v2)
{
	if (fabs(v1->x - v2->x) < 0.001f)
		if (fabs(v1->y - v2->y) < 0.001f)
			if (fabs(v1->z - v2->z) < 0.001f)
				return(true);

	return(false);
}

/************************** UVS ARE CLOSE ENOUGH ****************************/

inline Boolean UVsAreCloseEnough(TQ3Param2D *v1, TQ3Param2D *v2)
{
	if (fabs(v1->u - v2->u) < 0.01f)
		if (fabs(v1->v - v2->v) < 0.01f)
			return(true);

	return(false);
}


/************************** VECTORS ARE CLOSE ENOUGH ****************************/

inline Boolean VectorsAreCloseEnough(TQ3Vector3D *v1, TQ3Vector3D *v2)
{
	if (fabs(v1->x - v2->x) < 0.005f)
		if (fabs(v1->y - v2->y) < 0.005f)
			if (fabs(v1->z - v2->z) < 0.005f)
				return(true);

	return(false);
}


/************************** COLORS ARE CLOSE ENOUGH ****************************/

inline Boolean ColorsAreCloseEnough(TQ3ColorRGB *v1, TQ3ColorRGB *v2)
{
	if (fabs(v1->r - v2->r) < 0.001f)
		if (fabs(v1->g - v2->g) < 0.001f)
			if (fabs(v1->b - v2->b) < 0.001f)
				return(true);

	return(false);
}


