//
// reduction.h
//


#define	MAX_DECOMPOSED_TRIMESHES	200
#define	MAX_POINT_REFS				15					
#define	MAX_DECOMPOSED_POINTS		50000
#define	MAX_DECOMPOSED_NORMALS		50000

			/* DECOMPOSED POINT INFO */
			
typedef struct
{
	TQ3Point3D	realPoint;							// point coords as imported in 3DMF model
	
	Byte		numRefs;							// # of places this point is used in the geometry data
	Byte		triMeshNum[MAX_POINT_REFS];			// triMesh # of references
	short		pointNum[MAX_POINT_REFS];			// index into pointlist of triMesh above
	short		whichNormal[MAX_POINT_REFS];		// index into gDecomposedNormalsList
	
	Boolean		isAttached;							// flag set if its attached to a bone
}DecomposedPointType;

			/* DECOMPOSED NORMAL INFO */
			
typedef struct
{
	TQ3Vector3D	realVector;							// normal vector as imported in 3DMF model
	TQ3Vector3D	transformedVector;					// after its been transformed
}DecomposedNormalType;
